routes/web.php
<?php

use App\Http\Controllers\AlumnoController;
use App\Http\Controllers\CursoController;
use App\Http\Controllers\PerteneceController;
use App\Http\Controllers\PracticaController;
use App\Http\Controllers\PresentaController;
use Illuminate\Support\Facades\Route;

Route::get('/', function () {
    return view('index');
})->name('inicio');

//enrutamiento controlador alumno
Route::resource('alumno', AlumnoController::class);

//enrutammiento controlador curso
Route::resource('curso', CursoController::class);

//enrutamiento controlador practica
Route::resource('practica', PracticaController::class);

//enrutamiento controlador presentacion
Route::resource('presenta', PresentaController::class);


//enrutamiento controlador pertenece
Route::resource('pertenece', PerteneceController::class);

//enrutamiento adicional para practicas
Route::controller(PracticaController::class)->group(function () {
    Route::get('practica/confirmar/{practica}', 'confirmar')
        ->name('practica.confirmar');
});

app/Models/Pertenece.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Support\Facades\Schema;

class Pertenece extends Model
{
    use HasFactory;

    //nombre de la tabla
    protected $table = 'perteneces';

    //campos de asignacion masiva
    protected $fillable = [
        'alumno_id',
        'curso_id',
    ];

    //creamos atributo estatico con los labels
    public static $labels = [
        'id' => 'ID',
        'alumno_id' => 'ID del Alumno',
        'curso_id' => 'ID del Curso',
    ];

    //metodo para devolver el label de un campo
    public function getAttributeLabel($key)
    {
        return self::$labels[$key] ?? $key;
    }

    //metodo para devolver todos los campos
    public function getFields()
    {
        return Schema::getColumnListing($this->table);
    }

    //voy a crear las relaciones entre tablas
    //como la relacion es de muchos se pone en plural
    public function alumno(): BelongsTo
    {
        return $this->belongsTo(Alumno::class, 'alumno_id');
    }

    public function curso(): BelongsTo
    {
        return $this->belongsTo(Curso::class, 'curso_id');
    }
}

app/Http/Controllers/PerteneceController.php
<?php

namespace App\Http\Controllers;

use App\Models\Alumno;
use App\Models\Curso;
use App\Models\Pertenece;
use Illuminate\Http\Request;

class PerteneceController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $perteneces = Pertenece::all();
        return view('pertenece.index', compact('perteneces'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        //tenemos que crear los cursos y alumnos para crear los desplegables
        $cursos = Curso::all();
        $alumnos = Alumno::all();

        //devolvemos la vista
        return view('pertenece.create', compact('cursos', 'alumnos'));
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        //creamos el registro
        $pertenece = Pertenece::create($request->all());
        //redirigimos
        return redirect()
            ->route('pertenece.show', $pertenece);
    }

    /**
     * Display the specified resource.
     */
    public function show(Pertenece $pertenece)
    {
        //devolvemos la vista
        return view('pertenece.show', compact('pertenece'));
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Pertenece $pertenece)
    {
        //tenemos que crear los cursos y alumnos para crear los desplegables
        $cursos = Curso::all();
        $alumnos = Alumno::all();

        //devolvemos la vista
        return view('pertenece.edit', 
        compact('pertenece', 'cursos', 'alumnos'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Pertenece $pertenece)
    {
        //actualizamos el registro
        $pertenece->update($request->all());
        //redirigimos
        return redirect()
            ->route('pertenece.show', $pertenece);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Pertenece $pertenece)
    {
        //borramos el registro
        $pertenece->delete();
        //redirigimos
        return redirect()
            ->route('pertenece.index');
    }
}

resources/views/pertenece/create.blade.php
@extends('layouts.main')

@section('content')
<div>
    <h1>Gestion de alumnos y cursos</h1>
</div>
    <form action="{{ route('pertenece.store') }}" method="post" enctype="multipart/form-data">
        @csrf
        <div>
            <label>Selecciona el Alumno</label>
            <select name="alumno_id">
                @foreach ($alumnos as $alumno)
                    <option value="{{ $alumno->id }}">{{ $alumno->id }} - {{ $alumno->nombre }} {{ $alumno->apellidos }}</option>
                @endforeach
            </select>
        </div>
        <div>
            <label>Selecciona el curso</label>
            <select name="curso_id">
                @foreach ($cursos as $curso)
                    <option value="{{ $curso->id }}">{{ $curso->id }} - {{ $curso->nombre }}</option>
                @endforeach
            </select>
        </div>
        <div>
            <button type="submit" class="boton">Guardar</button>
        </div>
    </form>
@endsection

resources/views/pertenece/edit.blade.php
@extends('layouts.main')

@section('content')
<div>
    <h1>Cambiar alumno o curso</h1>
</div>
    <form action="{{ route('pertenece.update', $pertenece) }}" method="post" enctype="multipart/form-data">
        @csrf
        @method('PUT')
        <div>
            <label>Selecciona el Alumno</label>
            <select name="alumno_id">
                @foreach ($alumnos as $alumno)
                    <option value="{{ $alumno->id }}" 
                        {{ old('alumno_id', $pertenece->alumno_id) == $alumno->id ? 'selected' : '' }}>
                        {{ $alumno->id }} - {{ $alumno->nombre }} {{ $alumno->apellidos }}</option>
                @endforeach
            </select>
        </div>
        <div>
            <label>Selecciona el curso</label>
            <select name="curso_id">
                @foreach ($cursos as $curso)
                <option value="{{ $curso->id }}" 
                    {{ old('curso_id', $pertenece->curso_id) == $curso->id ? 'selected' : '' }}>
                    {{ $curso->id }} - {{ $curso->nombre }}</option>
                @endforeach
            </select>
        </div>
        <div>
            <button type="submit" class="boton">Actualizar</button>
        </div>
    </form>
@endsection

resources/views/pertenece/index.blade.php
@extends('layouts.main')

@section('content')
    <h1>Pertenece</h1>
<div class="listado">
    @foreach ($perteneces as $pertenece)
        <div class="tarjeta">
            <ul>
                <li>{{ $pertenece->id }}</li>
                <li>Alumno: {{ $pertenece->alumno_id }} {{ $pertenece->alumno->nombre }} {{ $pertenece->alumno->apellidos }}
                </li>
                <li>perteneces: {{ $pertenece->curso_id }} {{ $pertenece->curso->nombre }}</li>
            </ul>
            <div class="botones">
                <a href="{{ route('pertenece.show', $pertenece) }}" class="boton">Ver</a>
                <a href="{{ route('pertenece.edit', $pertenece) }}" class="boton">Editar</a>
                <form action="{{ route('pertenece.destroy', $pertenece) }}" method="post" id="eliminar">
                    @csrf
                    @method('delete')
                    <button type="submit" class="boton">Borrar</button>
                </form>
            </div>
        </div>
    @endforeach
</div>
@endsection

resources/views/pertenece/show.blade.php
@extends('layouts.main')

@section('content')
    <div class="tarjeta">
        <ul>
            <li>{{ $pertenece->id }}</li>
            <li>Alumno: {{ $pertenece->alumno_id }} {{ $pertenece->alumno->nombre }} {{ $pertenece->alumno->apellidos }}</li>
            <li>Curso: {{ $pertenece->curso_id }} {{ $pertenece->curso->nombre }}</li>
        </ul>
        <div class="botones">
            <a href="{{ route('pertenece.edit', $pertenece) }}" class="boton">Editar</a>
            <form action="{{ route('pertenece.destroy', $pertenece) }}" method="post" id="eliminar">
                @csrf
                @method('delete')
                <button type="submit" class="boton">Borrar</button>
            </form>
        </div>
    </div>
@endsection